#ifndef FTP_H
#define FTP_H

#include "mdata.h"

/************  FTP (FTP.c) abbreviations  *************/
#define NUMDATAWORDSFTPCPPR 10241
#define FTPADCR_FORMAT 0
#define FTPADCD_FORMAT 0 /* uncompressed */
#define PADSPERFTPSECTOR 320

/*******************************  typedefs  *****************/
typedef struct {
  int pad,row;
} FTPPAD_T;
typedef struct {
  int sector[HITSPEREVENT];
  int row[HITSPEREVENT];
  int pad[HITSPEREVENT];
  int cbin[HITSPEREVENT];
  int nhit;
} FTPEVENT_T;
typedef struct {
  ulong oADCD,oSEQD;
  int rowNumber;
} FTPADCX_T;

/************  FTP (FTP.c) globals  *********/ 
ulong gFTPCPP[NUMDATAWORDSFTPCPPR];
int gFTPOtherBank; /* int is OK */
FTPEVENT_T gFTPEvent[EVENT];
FTPPAD_T gFTPP[PAD];
                    /* This distribution scheme may be flawed. */
FTPADCX_T gFTPADCX[2]; /* row 1 to [0], row 2 to [1] */

ulong gNumFTPADCX;
int gNFTPpad;

/************  FTP (FTP.c) functions  *******/
void InitGlobalsForFTPCPPR(void);
void PrepareGlobalsForFTPCPPR(ulong whichPad,ulong nCenterbins,ulong *cbin);
void WriteBodyFTPCPPR(char swapbytes,ulong junk);
ulong FTPOoo(ulong xx);
void WriteBodyFTPP(char swapbytes,ulong eventNum0);
void WriteBodyFTPCHAP(char swapbytes,ulong eventNum1);
void WriteBodyFTPRBP(char swapbytes,ulong notUsed);
void WriteBodyFTPAZIP(char swapbytes,ulong notUsed);
void WriteBodyFTPMZP(char swapbytes,ulong notUsed);
void FillLongsForThisFTPPad(ulong nCenterbins,ulong *cbin,ulong *data);
void FillLongsForFTPPADK(ulong *data);
void WriteBodyFTPPADK(char swapbytes,ulong eventNum0);
void WriteBodyFTPADCR(char swapbytes,ulong eventAndSector);
void GetFTPHitsThisSector(ulong event,ulong sector1,
      ulong *row,ulong *pad,ulong *cbin,ulong *nhits);
void WriteBodyFTPSEQD(char swapbytes,ulong arg);
void WriteBodyFTPADCD(char swapbytes,ulong arg);
void WriteBodyFTPADCX(char swapbytes,ulong arg);
ulong NumFTPHits(ulong ev0,ulong sector1);
void InitTheFTPComment73xGlobals(void);

#endif
