/***********************************************************************/
/* For dumping binary files to screen. */
/******************************************  includes  *****************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
/*****************************************  abbreviations  *************/
#define ERR Err(__LINE__)
#define PP printf(
#define EE fprintf(stderr,
/*****************************************  globs  **************/
char gPrint;
/*****************************************  typedefs    ****************/
/*****************************************  navigation  ****************/
/********************************************* static memory ***********/
/*********************************************  functions  *************/
void Err(int ln) {
  PP"Error :%d\n",ln); exit(1);
}
void Usage(char *xx) {
  EE"usage: %s filename OFFSET NWORDS\n",xx);
  EE"skips OFFSET word in file before beginning reading.\n");
  EE"does a total of NWORDS words\n");
  exit(2);
}
/*
123 | ab 123 L | ab 123 L | ab 123 L | ab 123 L | abcd abcd | 1234567890 | 123
*/
int Page(char *x) {
  int which,ii;
  static int hh[50];
  static char init=0;
  if(!init) { init=7; for(ii=0;ii<50;ii++) hh[0]=0; }
       if(!strcmp(x,"LRHD"))    which= 0;
  else if(!strcmp(x,"DATAP"))   which= 1;
  else if(!strcmp(x,"TPCP"))    which= 2;
  else if(!strcmp(x,"TPCSECP ")) which= 3;
  else if(!strcmp(x,"TPCRBP  "))  which= 4;
  else if(!strcmp(x,"TPCMZP  "))  which= 5;
  else if(!strcmp(x,"TPCADCR ")) which= 6;
  else if(!strcmp(x,"TPCPADK ")) which= 7;
  else if(!strcmp(x,"TPCADCD ")) which= 8;
  else if(!strcmp(x,"TPCSEQD ")) which= 9;
  else if(!strcmp(x,"TPCADCX ")) which=10;
  else if(!strcmp(x,"FTPP"))    which= 11;
  else if(!strcmp(x,"FTPCHAP ")) which= 12;
  else if(!strcmp(x,"FTPRBP  "))  which= 13;
  else if(!strcmp(x,"FTPAZIP ")) which= 14;
  else if(!strcmp(x,"FTPMZP  "))  which= 15;
  else if(!strcmp(x,"FTPADCR ")) which= 16;
  else if(!strcmp(x,"FTPPADK ")) which= 17;
  else if(!strcmp(x,"FTPADCD ")) which= 18;
  else if(!strcmp(x,"FTPSEQD ")) which= 19;
  else if(!strcmp(x,"FTPADCX ")) which= 20;
  else return -123;
  return ++(hh[which]);
}
void PrintHrule(int fd,char *fromFile) {
  char tmp[4],banktype[19]; void *ptr;
  int ii;
  ptr=tmp;
  for(ii=0;ii<4;ii++) banktype[ii]=fromFile[ii];
  if(read(fd,ptr,4)!=4) ERR;
  lseek(fd,-4,SEEK_CUR);
  for(ii=0;ii<4;ii++) banktype[ii+4]=tmp[ii];
  banktype[9]=0;
  banktype[19]=0;
  /* if(strstr(banktype,"TPCSECP")) gPrint=7; else gPrint=0; */
  if(gPrint) {
    PP"----------+----- %-8s ------+- instance %3d ------",
      banktype,Page(banktype));
    PP"+-----------+------------+------\n");
  }
}
ulong SizeOfFile(char *fn) {
  char *cc,line[111],com[123];
  FILE *ff;
  sprintf(com,"ls -lL %s > /tmp/junkOIP",fn); system(com);
  ff=fopen("/tmp/junkOIP","r"); if(!ff) ERR;
  if(!fgets(line,100,ff)) ERR; fclose(ff);
  strtok(line," \n");
  strtok(NULL," \n");
  strtok(NULL," \n");
  strtok(NULL," \n");
  cc=strtok(NULL," \n"); if(!cc) ERR;
  return atol(cc);
}
int main(int nnn,char *aaa[]) {
  unsigned long int asLongInt,wordnumber,sss; off_t skip=0;
  int printme,cnt=0,ii,fd,k,cntLRHD=0,nwords;
  unsigned short int *rr;
  char *mark,lbuf[200],buf2[60],startNewBank,startNewBankPrev;
  unsigned char q,fromFile[4];
  void *ptr;
  if(nnn!=4) Usage(aaa[0]); ptr=fromFile; rr=ptr; gPrint=7;
  sss=SizeOfFile(aaa[1]);
  /* fprintf(stderr,"Size of file is %d bytes\n",sss); */
  skip=atol(aaa[2])*4;
  nwords=atol(aaa[3]);
  fd=open(aaa[1],O_RDONLY); if(fd<0) ERR;
  lseek(fd,skip,SEEK_SET);
  for(wordnumber=skip/4;;wordnumber++) {
    if(wordnumber-skip/4>=nwords) break;
    if(wordnumber%30270==0) {
      /* fprintf(stderr,"%3d %% done\n",(400*wordnumber)/sss); */
    }
    if(read(fd,ptr,4)!=4) { exit(2); }
    sprintf(lbuf,"%9d | ",(wordnumber+1)); startNewBank=7;

    /* as four bytes */
    for(ii=0;ii<4;ii++) {
      q=fromFile[ii];
      if(!(q>='A'&&q<='Z')) startNewBank=0;
      if((q>='a'&&q<='z')||(q>='A'&&q<='Z')) {
        sprintf(buf2,"%02x %3d %c | ",fromFile[ii],fromFile[ii],fromFile[ii]);
      } else {
        sprintf(buf2,"%02x %3d %c | ",fromFile[ii],fromFile[ii],' ');
      }
      if(fromFile[ii]==0) { for(k=0;k<6;k++) { if(buf2[k]=='0') buf2[k]=' '; } }
      strcat(lbuf,buf2);
    }

    /* as two shorts */
    for(ii=0;ii<2;ii++) {
      sprintf(buf2,"%04x ",rr[ii]); strcat(lbuf,buf2);
    }
    strcat(lbuf,"| ");

    /* as one long */
    asLongInt=*((long int*)ptr);
    sprintf(buf2,"%10u",asLongInt);
    strcat(lbuf,buf2); strcat(lbuf," | ");

    if(cntLRHD>11&&startNewBank&&!startNewBankPrev) {
      cnt=0; PrintHrule(fd,fromFile);
    }
    cnt++; cntLRHD++;
    if(cnt>10) { mark=""; printme=cnt-10; } else { mark="h"; printme=cnt;}
    sprintf(buf2,"%3d",printme); strcat(lbuf,buf2);
    startNewBankPrev=startNewBank;
    if(asLongInt==1145590348) cntLRHD=0; /* so the DATA word in the LHRD bank
                                         ** does not trigger "new bank" */
    if(gPrint&&asLongInt) PP"%s %s\n",lbuf,mark);
  }
}
